Sol32 App
my_sol_app
A simple Solar_OS window with a drawn text message
[*BEGINPRO*]
[*BEGINDEF*]
[MakeDef]
Menu=1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0
1=
2=5,O,sol_asm2.exe $2 $5 /pe32  /info
3=
4=0,0,,5
5=
6=
7=
[MakeFiles]
0=my_sol_app.rap
1=my_sol_app.rc
2=my_sol_app.asm
3=my_sol_app.obj
4=my_sol_app.res
5=my_sol_app.exe
6=my_sol_app.def
7=my_sol_app.dll
8=my_sol_app.txt
9=my_sol_app.lib
10=my_sol_app.mak
11=my_sol_app.hla
[Resource]
[StringTable]
[Accel]
[VerInf]
[Group]
Group=Added files,Assembly,Resources,Misc,Modules
1=2
[*ENDDEF*]
[*BEGINTXT*]
my_sol_app.Asm
;--------------------------------------------
; This app defines a window and 
; prints a text inside it
;--------------------------------------------


;----------------------------
; imports 
;----------------------------
import_dll sol_os_kernel.dll		; dummy dll
	import	Window_Create
	import	Window_Set_Caption
	import	Window_Set_Callback
	import	Window_Set_Min_Size

	import	Text_Draw
	import	Str_Printf CDECL


;----------------------
; define sections
;----------------------
section "code"		class_code
section "data" 		class_data
section	"idata"		class_imports
section "reloc" 	class_relocs


;------------------------------
; includes
;------------------------------
include		\sol_asm\include\sol32\system_32_equ.asm

;------------------------------
; program text
;------------------------------

.data
	main_handle		dd	0
	main_caption		db	"Sol Text Output Sample",0
	text_str		db	"Hello World",0
	tmp_buff1		rb	128

.code

.entry App_Init

App_Init:
	;----------------------------------
	; create main application window
	;----------------------------------	
	mov	eax,FLAG_WND_ALPHA+FLAG_WND_MINI
	invoke	Window_Create,0,128,128,320,200,eax,WND_TYPE_TOP
	mov	[main_handle],eax

	;-----------------
	; set caption
	;-----------------
	invoke	Window_Set_Caption, eax, main_caption

	;-----------------
	; set callback
	;-----------------
	invoke	Window_Set_Callback,[main_handle],OS_CALL_AFTER,Main_Callback

	;-------------------------------------
	; set minimum resize values
	;-------------------------------------
	invoke	Window_Set_Min_Size,[main_handle],200,108

	; done
	mov	eax,[main_handle]
	ret



PROC Main_Callback STDCALL
	USES	ebx,edx,esi,edi
	ARG	wnd_handle,wnd_action,wnd_param1,wnd_param2

	;------------------------------------
	; switch on message type
	;------------------------------------
	mov	eax,[wnd_action]

	.IF eax == ACT_PAINT
		;-----------------------
		; paint text 
		;-----------------------
		invoke	Text_Draw,[wnd_handle],160,32,text_str,0ff3f1fh
	.ENDIF

	xor	eax,eax
	ret
ENDP

;******************************
;  END OF PROGRAM TEXT
;******************************

[*ENDTXT*]
[*ENDPRO*]
